/** 
 * Copyright (c) 2010-2015 iNTERFACEWARE Inc.  All rights reserved.
 */

var SCMreplaceSampleStr = 'REPLACE_SAMPLE';
var SCMappendSampleStr = 'APPEND_SAMPLE';

if (!Array.prototype.indexOf) {
   Array.prototype.indexOf = function (obj, start) {
      for (var i = (start || 0), j = this.length; i < j; i++) {
         if (this[i] === obj) {
            return i;
         }
      }
      return -1;
   }
}

function SCMcommitDlgGetConflictingFiles(Editor, ProjectData) {
   SCMcheckConflicts(Editor, ProjectData, SCMcommitDlgUI);
}

function handleProjectImportError(RequestObject, Status, ErrorString){
   var ErrorMessage = RequestObject.responseJSON.error
                      ? RequestObject.responseJSON.error.description
                      : RequestObject.status + " - " + RequestObject.statusText;
   $(document).find("body").append($("<div id='scResponseDlg'><div class='sc_error'></div><br/></div>"));
   var ResponsePopup = $("#scResponseDlg");
   var DlgButtons = {};
   DlgButtons['Close'] = function () {
      $(this).dialog('close');
   }
   // TODO: properly dimension the dialog based on the parent
   ResponsePopup.dialog({
      bgiframe: true,
      width:    400,
      title:    "Error",
      modal:    true,
      autoOpen: false,
      buttons:  DlgButtons
   });
   ResponsePopup.find('.sc_error').text(ErrorMessage);
   ResponsePopup.find('.sc_error').show();
   ResponsePopup.dialog("open");
   return true;
}

function SCMclearDependencies(Editor) {
   var Params = {
      'translator_guid' : Editor.ifware.ChannelGuid
   };
   $.ajax({
      url    : "/sc/clear_dependencies",
      method : "POST",
      data   : Params,
      success: function(Response){
         SCMresponseDlgUI(Response, false);
      },
      error  : handleProjectImportError
   });
}

function SCMresponseDlgUI(Response, ShowInfo, Callback) {
   if ($('#scResponseDlg').length) {
      $('#scResponseDlg').remove();
   }
   if (typeof Callback == 'function') Callback();
   return false;
}

function SCMgetMainFileLabel(ProjectData) {
   for (var i = 0; i < ProjectData.length; ++i) {
      if (ProjectData[i].Type == "Main") {
         return (ProjectData[i].Label);
      }
   }
   return "";
}

// Returns labels, paths, or anything else that's in ProjectData
function SCMgetProjectList(ProjectData, KeyName) {
   var List = new Array();
   for (var i = 0; i < ProjectData.length; ++i) {
      List.push(ProjectData[i][KeyName]);
   }
   return List;
}

function SCMdialogWaiting(DialogSelector, BoolWaiting) {
   if (BoolWaiting) {
      $(DialogSelector).dialog("disable");
      $(DialogSelector).siblings('.ui-dialog-buttonpane').prepend('<img class="scSpinner" src="/js/mapper/images/spinner.gif" />');
   } else {
      $(DialogSelector).dialog("enable");
      $(DialogSelector).siblings('.ui-dialog-buttonpane').children('.scSpinner').remove();
   }
}

function SCMdialogConfirm(ConfirmText, Callback) {
   if ($('#fossilConfirmDlg').length) {
      $('#fossilConfirmDlg').remove();
   }
   $(document).find("body").append($("<div id='fossilConfirmDlg'>" + ConfirmText + "</div>"));

   var DlgButtons = {};
   DlgButtons['No'] = function () {
      $(this).dialog('close');
   }

   DlgButtons['Yes'] = function () {
      Callback();
      $(this).dialog('close');
   }

   // TODO: properly dimension the dialog based on the parent
   var PopupDialog = $("#fossilConfirmDlg");

   PopupDialog.dialog({
      bgiframe:   true,
      title:      "Confirmation Request",
      width:      500,
      modal:      true,
      autoOpen:   false,
      buttons:    DlgButtons
   });
   PopupDialog.dialog("open");
}

function SCMrevertConfirmText() {
   return "Revert operation might overwrite your changes. Are you sure you want to revert?";
}

function SCMactivateUploadedZip(Editor, FileName) {
   var Params = {
      'translator_guid'   : Editor.ifware.ChannelGuid, 
      'uploaded_filename' : FileName, 
      'data_import_type'  : Editor.ifware.DataImportType
   };

   function importFromZipSuccess(Response){
      if (Editor.ifware.DataImportType == SCMreplaceSampleStr) {
         Editor.ifware.setCountOfSample(Response.CountOfSampleData);
         Editor.ifware.setSampleIndex(1);
         NISchangeSampleData(Editor, 1);
      } else if (Editor.ifware.DataImportType == SCMappendSampleStr) {
         Editor.ifware.setCountOfSample(Editor.ifware.countOfSample() + Response.CountOfSampleData);
      }
      NISupdateSampleDataControl(Editor);
      NISreloadCurrentFile(Editor);
   }

   $.ajax({
      url    : "/sc/import_from_zip",
      method : "POST",
      data   : Params,
      error  : handleProjectImportError,
      success: importFromZipSuccess
   });
}

function SCMuploadFile(Dialog, Form, fileInput, Editor, ProjectManager) {
   ProjectManager.handleProjectUpload(Form, Dialog, fileInput);
}

function SCMenableImportBTN(Dialog, enable) {
   Dialog.dialog('widget').find('button:contains("Import")').button(enable);
}

function SCMimportProjectAndData(Editor, ProjectManager) {
   console.log("SCMimportProjectAndData");
   console.log(ProjectManager);
   var DialogId = 'importProjectAndData';
   $('#' + DialogId).remove();
   $(document).find("body")
      .append('<div id="' + DialogId + '">' +
      '<form id="importForm">' +
      '<table>' +
      '<tr><td valign="top"><input type="radio" name="import_type" value="EmptyProject" id="' + DialogId + '_importTypeId" class="ImportBlank"></td><td ><label for="' + DialogId + '_importTypeId">Use a blank project</label></td>' +
      '<tr><td valign="top"><input type="radio" id="' + DialogId + '_projectList" name="import_type" value="ImportProject" class = "ImportFromProject"></td>' +
      '    <td><label for="' + DialogId + '_projectList">Import from existing projects</label>' +
      '        <br><select name="projectList"></select>' +
      (Editor.ifware.UsesParameter ?
         '        <br><input id="' + DialogId + '_importSampleData" type="checkbox" name="importSampleData" checked="checked">' +
            '        <label for="' + DialogId + '_importSampleData">Import sample data</label>' : '') +
      '<tr><td valign="top"><input type="radio" name="import_type" value="ImportZippedProject" id="' + DialogId + '_importZipFile' + '" class = "ImportFromZip"></td>' +
      '    <td><label for="' + DialogId + '_importZipFile">Import project from zip file</label>' +
      '<br><input type="file" id="ImportZipFileBrowse" name="NewFile" value = ""/>\
      <input type="hidden" name="translator_guid" value="' + Editor.ifware.ChannelGuid + '" />\  ' +
      (Editor.ifware.UsesParameter ?
         '<br><input id = "' + DialogId + '_includeSampleData" type = "checkbox" name = "includeSampleData" checked="checked">' +
            '  <label for="' + DialogId + '_includeSampleData">Import sample data</label>' +
            // Only include the option to append or replace if the project already has sample data.
            (Editor.ifware.countOfSample() > 0 ? '   <select name="addSampleTypeList">' +
               '<option value = "APPEND_SAMPLE">Append</option>' + '<option value = "REPLACE_SAMPLE">Replace</option>' +
               '</select>' : '') : '') +
      '</td></tr></table>' +
      '</form>' +
      '<div class="importError" style="color: red"></div>' +
      '</div>');

   var ImportDialog = $('#' + DialogId);

   function onToggleType() {
      if ($('#ImportZipFileBrowse', ImportDialog).val() == "" && $('input[name=import_type]:checked', ImportDialog).val() == "ImportZippedProject") {
         SCMenableImportBTN(ImportDialog, 'disable');
      }

      else {
         SCMenableImportBTN(ImportDialog, 'enable');
      }
   }

   // Select the blank project button by default if the project is new.
   if (NISmainFileSelectedAndEmpty(Editor)) {
      $('input[class = "ImportBlank"]').prop('checked', true);
   }
   else {
      $('input[class = "ImportFromProject"]').prop('checked', true);
   }

   $('input[name=import_type]', ImportDialog).click(function () {
      onToggleType()
   });
   $('input[name = NewFile]', ImportDialog).change(function () {
      SCMenableImportBTN(ImportDialog, 'enable');
   });

   $('select[name = projectList]', ImportDialog).mousedown(function () {
      $('input[class = "ImportFromProject"]').prop('checked', true);
      $(".importError").html(""); //clear error if existing.
      onToggleType()
   });
   $('input[name = importSampleData]', ImportDialog).click(function () {
      $('input[class = "ImportFromProject"]').prop('checked', true);
      onToggleType()
   });
   $('input[name = NewFile]', ImportDialog).click(function () {
      $('input[class = "ImportFromZip"]').prop('checked', true);
      onToggleType()
   });
   $('input[name = includeSampleData]', ImportDialog).click(function () {
      $('input[class = "ImportFromZip"]').prop('checked', true);
      onToggleType()
   });
   $('select[name = addSampleTypeList]', ImportDialog).mousedown(function () {
      $('input[class = "ImportFromZip"]').prop('checked', true);
      onToggleType()
   });

   var DlgButtons = {};
   DlgButtons['Import'] = function importButtonCallback() {
      if ('ImportProject' == $('input[name=import_type]:checked', this).val()) {
         Editor.ifware.CurrentSourceHash = null;
         var SourceGuid = $('select[name=projectList] option:selected', this).val();
         if (!SourceGuid) $(this).dialog('close');
         SCMdialogWaiting('#' + DialogId, true);
         var Params = {'translator_guid':Editor.ifware.ChannelGuid, 'source_guid':SourceGuid};
         if ($('input[name=importSampleData]:checked', this).length && Editor.ifware.UsesParameter) {
            Params.import_sample_data = 'true';
         }

         function importFromProjectSuccess(Response){
            SCMdialogWaiting('#' + DialogId, false);
            Editor.ifware.setCountOfSample(Editor.ifware.countOfSample() + Response.import_count);
            NISupdateSampleDataControl(Editor);
            NISreloadCurrentFile(Editor);
            $(ImportDialog).dialog('close');
         }

         function importFromProjectError(RequestObject, Status, ErrorString){
            SCMdialogWaiting('#' + DialogId, false);
            var ErrorMessage = RequestObject.responseJSON.error
                   ? RequestObject.responseJSON.error.description
                   : RequestObject.status + " - " + RequestObject.statusText;
            $('.importError', ImportDialog).html(ErrorMessage);
         }

         $.ajax({
            url    : "/sc/import_from_project",
            method : "POST",
            data   : Params,
            error  : importFromProjectError,
            success: importFromProjectSuccess
         });    
      }
      else if ('ImportZippedProject' == $('input[name=import_type]:checked', this).val()) {
         Editor.ifware.CurrentSourceHash = null;
         var Form = ImportDialog.find('form');
         var fileInput = Form.find('input[type="file"]');

         if ($('input[name=includeSampleData]:checked').length && Editor.ifware.UsesParameter) {
            if ($('select[name=addSampleTypeList] option:selected', this).val() == 'APPEND_SAMPLE' ||
               Editor.ifware.countOfSample() == 0) { // default to append if the project doesn't have any sample data
               Editor.ifware.DataImportType = SCMappendSampleStr;
            }
            else {
               Editor.ifware.DataImportType = SCMreplaceSampleStr;
            }
         }
         else {
            Editor.ifware.DataImportType = "";
         }

         SCMuploadFile(ImportDialog, Form, fileInput, Editor, ProjectManager);

      }
      else {
         var MainCode = '';
         var ProductText = MPRapp ? ' from '+MPRapp.type : '';
         if (Editor.ifware.UsesParameter) {
            var MainCode = '-- The main function is the first function called' + ProductText + '.\n\
-- The Data argument will contain the message to be processed.\n\
function main(Data)\n\
end';
         } else {
            var MainCode = '-- The main function is the first function called' + ProductText + '.\n\
function main()\n\
end';
         }
         NISsetScriptName(Editor, Editor.ifware.MainLuaFile);
         Editor.setValue(MainCode); //this should trigger an annotation update
         Editor.clearHistory();
         SCMclearDependencies(Editor);
         $(ImportDialog).dialog('close');
      }
   }
   DlgButtons['Cancel'] = function () {
      $(this).dialog('close');
   }

   ImportDialog.dialog({
      bgiframe:   true,
      title:      Editor.ifware.UsesParameter ? 'Import Project/Sample Data' : 'Import Project',
      resizable:  false,
      modal:      true,
      autoOpen:   false,
      buttons:    DlgButtons,
      close: function (event, ui) {
         Editor.focus();
      }
   });

   onToggleType();

   //only open the dialog when the response comes back, in case mini login is to be displayed.
   ImportDialog.dialog("open");
   SCMdialogWaiting('#' + DialogId, true);

   function handleProjectsFileInfoError(RequestObject, Status, ErrorString){
         ImportDialog.dialog("close");
         SCMdialogWaiting('#' + DialogId, false);
         handleProjectImportError(RequestObject, Status, ErrorString);
   }

   function handleProjectsFileInfoSuccess(Response){
         SCMdialogWaiting('#' + DialogId, false);
         var ProjNames = [];
         var ProjByName = {};
         Response.Projects.sort(function (Left, Right) {
            var LeftName = (Left.Name || Left.Guid).toLowerCase();
            var RightName = (Right.Name || Right.Guid).toLowerCase();
            if (LeftName < RightName) return -1;
            else if (LeftName > RightName) return 1;
            else return 0;
         });
         for (ProjIndex in Response.Projects) {
            var Proj = Response.Projects[ProjIndex];
            var NewOpt = $('<option></option>');
            NewOpt.val(Proj.Guid);
            NewOpt.html(Proj.Name || Proj.Guid);
            $('select[name=projectList]', ImportDialog).append(NewOpt);
         }
         var DialogWidth = $('#' + DialogId + ' table:first').width();
         ImportDialog.dialog('option', 'width', 26 + DialogWidth); //26 replicates padding width from the standard dialog
         ImportDialog.dialog('option', 'position', 'center'); //need to re-center
         SCMdialogWaiting('#' + DialogId, false);
   }

   var Params = { 'translator_guid' : Editor.ifware.ChannelGuid };
   $.ajax({
      url    : "/sc/get_all_projects_file_info",
      method : "POST",
      data   : Params,
      error  : handleProjectsFileInfoError,
      success: handleProjectsFileInfoSuccess
   });
}

function SCMincludeSampleConfirm(ChannelGuid) {
   $('#IncludeSampleConfirmDlg').remove();

   $(document).find("body")
      .append('<div id="IncludeSampleConfirmDlg" align="center">Include Sample Messages? </div>');

   var DlgButtons = {};

   DlgButtons['Yes'] = function () {
      SCMexportRequest(ChannelGuid, true);
      $('#IncludeSampleConfirmDlg').dialog('close');
   }

   DlgButtons['No'] = function () {
      SCMexportRequest(ChannelGuid, false);
      $('#IncludeSampleConfirmDlg').dialog('close');
   }

   $("#IncludeSampleConfirmDlg").dialog({
      bgiframe:   true,
      width:      300,
      height:     130,
      title:      'Confirm',
      modal:      true,
      autoOpen:   true,
      buttons:    DlgButtons
   });
}

function SCMexportRequest(ChannelGuid, IncludeSampleData) {
   window.open('/sc/export_to_zip?translator_guid=' + ChannelGuid + '&sample_data=' + IncludeSampleData);
   this.focus();
}


////////////////////////////

function SCMpluralLines(Count) {
   return (Count == 1) ? 'line' : 'lines';
}

function SCMfindLabel(Label, List) {
   for (var i = 0; i < List.length; i++) {
      if (List[i] == Label) {
         return true;
      }
   }
   return false;
}

function SCMdisplayError(ErrorMessage, ExitMethod){
   $('#scResponseDlg').remove();
   if (! ErrorMessage) { return false; }
   var Message = "<p> We're sorry, but an unexpected error occurred: </p>\
                    <p>" + ErrorMessage + "</p>\ ";
   $("body").append($("<div id='scResponseDlg'>\
                       <div class='sc_error'></div><br/>\
                       <div class='sc_output'></div><div class='sc_info'></div></div>\
                    "));
   var ResponsePopup = $("#scResponseDlg");
   var DlgButtons = {};
   DlgButtons['Close'] = function() {
      $(this).dialog('close');
   }
   ResponsePopup.dialog({
      bgiframe:true,
      width:600,
      title:"Error",
      modal:true,
      autoOpen:false,
      buttons:DlgButtons,
      close: function(event, ui) {
         ExitMethod();
      }
   });
   ResponsePopup.find('.sc_error').html(Message);
   ResponsePopup.find('.sc_error').show();
   ResponsePopup.dialog("open");
   return true;
}

// This is an older function that will detect any errors that
// may come down in a 200 response. 
// Most newer SC handlers will now send down a non-200 if there is an error.
function SCMcatchError(Response, ExitMethod) {
   if (! Response.ErrorMessage) { return false; }
   console.log("Caught error in response.");
   return SCMdisplayError(Response.ErrorMessage, ExitMethod);
}

function SCMupdateLegend(Diffs, Target) {
   var Lines = $(".toolbar_lines");
   Lines.html('');
   if (! Diffs.summary) {
      return;
   }
   var NewLegend = '<span class="label">Lines:</span>'
                 + '<span class="lines_info">Added: <span class="lines_added">'     + Diffs.summary.added   + '</span></span>'
                 + '<span class="lines_info">Deleted: <span class="lines_deleted">' + Diffs.summary.deleted + '</span></span>'
                 + '<span class="lines_info">Changed: <span class="lines_changed">' + Diffs.summary.changed + '</span></span>';
   Lines.html(NewLegend);
}

function SCMdrawDiffs(Diffs, Format) {
   if (Format == "condensed") {
      $("#SCMdiff").html(Diffs.condensed);
      $("#SCMdiff").addClass("changesOnly");
      return;
   }
   $("#SCMdiff").removeClass("changesOnly");
   var DiffClass = (Format == "vertical")
                   ? ' vrt'
                   : ''; 
   if(!Diffs.full){
      console.log("No diffs!");
      return;
   }
   var AllTheDiffs = $('<div class="diffTank' 
                      + DiffClass + '" id="diffFromTank"><div class="changeLabel">From</div><div class="diffCling">'
                      + Diffs.full.from
                      + '</div></div><div class="diffDivider'
                      + DiffClass + '" /><div class="diffTank'
                      + DiffClass + '" id="diffToTank"><div class="changeLabel">To</div><div class="diffCling">'
                      + Diffs.full.to + '</div></div>');
   $("#SCMdiff").html(AllTheDiffs);
   var $Both = $(".diffCling");
   var SyncDiffs = function(event) {
      var $OtherOne = $Both.not(this).off('scroll');
      var Other = $OtherOne.get(0);
      var top = $(this).scrollTop();
      var left = $(this).scrollLeft();
      if ($OtherOne.scrollTop()  != top ) { $OtherOne.scrollTop(top);   }
      if ($OtherOne.scrollLeft() != left) { $OtherOne.scrollLeft(left); }
      setTimeout(function() {
         $OtherOne.on("scroll", SyncDiffs);
      }, 70); // Firefox now does scrolling on another thread, so scroll events don't fire immediately.
              // 70 ms seems to be long enough to be sure the main thread has heard about a scroll.
              // Basically we want to prevent recursive scrolling events, where one column triggers the
              // other and that one triggers the original. Firefox is stoooopid.
   }
   $Both.on("scroll", SyncDiffs);
}

/////////
function SCMlights() {
   return ['red', 'yellow', 'green', 'gray']; // This matches the enum in DBDchannelStatus.h
}

function SCMinitialDiffs() {
   return {"condensed":'', "full": {"from":'', "to": ''}, "status": '', "summary": {"added": 0, "deleted": 0, "changed": 0}};
}

function SCMcompare(A, B, FieldName) {
   if (A[FieldName] > B[FieldName]) { return 1;  }
   if (A[FieldName] < B[FieldName]) { return -1; }
   return 0;
}

function SCMclip(Text, Length) {
   if (Text.length <= Length) { return Text; }
   return Text.substr(0, Length) + "...";
}

function SCMchannelConfigNameClip(Text, Length) {
   var RegEx  = /^\Channels\//;
   var RegEx2 = /-[A-F0-9]{32}\/ChannelConfiguration.xml$/;
   if (RegEx.test(Text)) {
      return SCMclip(Text.replace(RegEx, "").replace(RegEx2, ""), Length);
   }
   return SCMtranslatorNameClip(Text, Length);
}

function SCMtranslatorNameClip(Text, Length) {
   var RegEx  = /-(Ack|To|From|Filter|FromHTTP)-[A-Za-z0-9]{14}\//;
   var RegEx2 = /[A-F0-9]{32}\//;
   if (RegEx.test(Text)) {
      Text = Text.replace(RegEx, "-$1.../");
   } else if (RegEx2.test(Text)) {
      Text = Text.replace(RegEx2, ".../");
   }
   return Text.length <= Length
          ? Text
          : "..." + Text.substring(Text.length - Length);
}

function SCMsizeBoxes(FileCount, ProjectCount) {
   if (! ProjectCount) { return [100, 0]; }
   if (FileCount < 10)  { return [25, 74]; }
   var FileSize = FileCount / (FileCount + ProjectCount) * 100;
   if (FileSize > 75) { FileSize = 75; }
   return [FileSize, 99 - FileSize];
}

function SCMfileClasses(OneProject, PathMap) {
   if (! OneProject.shared_files) { return ''; }
   var Classes = ' ' + Object.keys(OneProject.shared_files).map(function(OneFile) {
      return PathMap[OneFile]["Index"];
   }).join(' ');
   if (OneProject.contains_new_file) {
      Classes += " NEW";
   }
   return Classes;
}

function SCMdecorate(CurrentIndex, FileScroll) {
console.log(CurrentIndex, FileScroll);
   $(".c").removeClass("c");
   $("#" + CurrentIndex).addClass("c");
   $(".h").removeClass("h");
   $("div.project." + CurrentIndex).addClass("h");
   $("div.project").on({
      "mouseenter": function(event) {
         $("span.file." + $(this).attr("id")).addClass("h");
      },
      "mouseleave": function(event) {
         $("span.file." + $(this).attr("id")).removeClass("h");
      }
   });
   $(".SCMstageLabel").each(function() {
      var Ht = $(this).outerHeight();
      $(this).next().css("top", Ht + "px");
   });
   $("#SCMstageFilesCollection").scrollTop(FileScroll);
}

function SCMfix() {
   var Container = $("#SCMcommitList");
   var Scroller = $(".scroller");
   Scroller.height(Container.height() - $(".fixed").outerHeight() + "px");
   Scroller.css("top", $(".fixed").outerHeight() + "px");
   $(".fixed table").width($(".scroller table").width() + "px");

   var PanelAndDiff = $("#SCMreviewPanelAndDiff");
   var HistoryBody = $("#HistoryBody");
   var Parent = PanelAndDiff.parent();
   var Cap = $(".EDT_toolbar_wrapper");
   var MasterHeight = Parent.height();
   if (Parent.is("#HistoryBody")) {
      MasterHeight = Parent.outerHeight();
   }
   if (Cap.length == 1) {
      MasterHeight -= Cap.outerHeight();
   }
   PanelAndDiff.height(MasterHeight - Container.outerHeight() - $("#SCMreviewControls").outerHeight() + "px");

   var DiffTank = $("#SCMdiffTank");
   var Toolbar = $(".diff_toolbar");
   $("#SCMdiff").height(DiffTank.height() - Toolbar.outerHeight() + "px");
   var Tree = $("ul.tree");
}

function SCMpullStatus(StatusMap, NoteText) {
   $.ajax({
      url: '/dashboard_data', 
      method: 'GET',
      cache: false,
      data: {
         include_remote_servers: true
      }, 
      success: function(Response) {
         SCMbumpStatus(Response, StatusMap, NoteText);
      }
   });
}

function SCMbumpStatus(Response, StatusMap, NoteText) {
   var LIGHTS = SCMlights();
   var Channels = Response.Channels
   for (var i = 0; i < Channels.length; i++) {
      var Cguid = Channels[i].Channel.Guid;
      var Light = LIGHTS[Channels[i].Channel.Light];
      if (Light == 'green') {
         StatusMap[Cguid] = true;
      } else {
         StatusMap[Cguid] = false;
      }
      var Ticks = $("input.bumpUpdate[data-cguid=" + Cguid + "]");
      SCMupdateBumpNote(Ticks, Cguid, StatusMap, NoteText);
      $("#BumpStatus_" + Cguid).html('<img src="/images/button-dot' + Light + 'v4.gif" alt="' + Light + '" />');
   }
}

function SCMupdateBumpNote(Ticks, Cguid, StatusMap, Text) {
   var Note = $("td#BumpNote_" + Cguid);
   Ticks.each(function() {
      if ($(this).prop("checked") && StatusMap[Cguid]) {
         Note.html(Text);
         return false;
      } else {
         Note.html("");
      }
   });
}

function SCMbumpTickCheck(BumpTicks, BumpAllTick, NoteText, DataAttr, StatusMap) {
   BumpTicks.on("change", function(event) {
      console.log("tick change");
      var AllThem = true;
      event.stopPropagation();
      var OneTick = $(this);
      var Val = OneTick.attr("data-" + DataAttr);
      console.log(Val);
      if (StatusMap) {
         console.log(StatusMap);
         console.log(StatusMap[Val]);
      }
      BumpTicks.each(function() {
         if (! $(this).prop("checked")) {
            AllThem = false;
            BumpAllTick.prop("checked", false);
         }
      });
      if (AllThem) {
         BumpAllTick.prop("checked", true);
      }
      var Ticks = $("input.bumpUpdate[data-" + DataAttr + "='" + Val + "']");
      if (StatusMap) {
         SCMpullStatus(StatusMap, NoteText);
         SCMupdateBumpNote(Ticks, Val, StatusMap, NoteText);
      }
   });
   BumpAllTick.on("change", function(event) {
      if ($(this).prop("checked")) {
         BumpTicks.prop("checked", true);
      } else {
         BumpTicks.prop("checked", false);
      }
      BumpTicks.trigger("change");
   });
}

function SCMcommitKeys(Index, Max, Callback) {
   console.log("Index: " + Index);
   console.log("Max: " + Max);
   SCMdisableMouse();
   if (Max == 0) { return; }
   var StarterIndex = Index;
   var Current = $("tr.commitRow.current");
   function watchKeys(event) {
      event.preventDefault();
      SCMdisableMouse();
      var Changed = false
      if (event.keyCode == 38 && Index < Max) {     // going up
         console.log("up");
         Index++;
         Changed = true;
      } else if(event.keyCode == 40 && Index > 0) { //going down
         console.log("down");
         Index--;
         Changed = true;
      }
      if (Changed) {
         console.log("new index: " + Index);
         Callback(Index, Current);
      }
      return false;
   }
   $("body").off("keydown.differ");
   $("body").on("keydown.differ", watchKeys);
   $("body").focus();
}

function SCMscrollCommitList() {
   var Current = $('tr.commitRow.current');
   var Pos = Current.position();
   if (Pos.top < 0) {
      Current[0].scrollIntoView(true);
   }
   if (Pos.top + Current.outerHeight() > $('.scroller').height()) {
      Current[0].scrollIntoView(false);
   }
}

function SCMdisableMouse() {
   $(".commitTable").removeClass("mouseworthy");
}

function SCMreEnableMouse() {
   $(".scroller .commitTable").addClass("mouseworthy");
}

function SCMlinkText(Text) {
   var RegEx = /(https?:\/\/\S*)/;
   return Text.replace(RegEx, function(Match) {
      return '<a href="' + Match + '" target="_blank">' + Match + '</a>';
   });
}



