/** @license
 * Copyright (c) 2010-2011 iNTERFACEWARE Inc.  All rights reserved.
 */

   //Only define this once per scope. Associative array holding last polled value.
if (PEXLastInput == undefined) {
   var PEXLastInput={};
}

function updatePath(Key, InputElement, PreviewSpan, PreviewDiv, EnvironmentOnly) {
   if (!InputElement) { return; }
   var UnexpandedPath = encodeURIComponent(InputElement.value);
   var PerformAjax = true;

   if(PEXLastInput[Key] != undefined && PEXLastInput[Key] == UnexpandedPath) {
      PerformAjax = false;
   }

   if (UnexpandedPath == "") {
      PerformAjax = false;
      PreviewDiv.style.display = "none";
   }

   if (PerformAjax == true) {
      PEXLastInput[Key] = UnexpandedPath;

      var AJAXCommandName;
      var AJAXVariableName;
      var PreviewPrefix;

      if (EnvironmentOnly) {
         AJAXCommandName = 'environment_expand';
         AJAXVariableName = 'RawText=';
         PreviewPrefix = 'Preview: "';
      } else {
         AJAXCommandName = 'path_expand';
         AJAXVariableName = 'RawPath=';
         PreviewPrefix = 'Absolute Path: "';
      }

      AJAXpost(AJAXCommandName, AJAXVariableName + UnexpandedPath, function(data) {
         try {
            var Response = JSON.parse(data);
            var PreviewText;
            if (Response) {
               if(EnvironmentOnly) {
                  PreviewText = Response.expandedText;
               } else {
                  PreviewText = Response.expandedPath;
               }
            }

            PreviewText = PreviewText.replace(/;/g, '&#59;');
            PreviewText = PreviewText.replace(/&(?!#59;)/g, '&amp;');
            PreviewText = PreviewText.replace(/</g, '&lt;');
            PreviewText = PreviewText.replace(/>/g, '&gt;');
            PreviewText = PreviewText.replace(/"/g, '&quot;');

            if (!Response || (PreviewText == undefined) || (PreviewText == unescape(UnexpandedPath))){
               PreviewDiv.style.display =  "none";
            } else {
               PreviewSpan.innerHTML = PreviewPrefix + PreviewText +'"';
               PreviewDiv.style.display =  "";
            }
         } catch(err) {
            //exception means that the response is not valid JSON.
            PreviewDiv.style.display =  "none";
         }
      });
   }
}

