<?cs include:"doctype.cs" ?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; License Entitlement</title>
   <?cs include:"browser_compatibility.cs" ?>
   <?cs include:"styles.cs" ?>

   <link rel="stylesheet" type="text/css" href="/js/jquery-1.11.2/jquery-ui-1.11.2/jquery-ui.css">

   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
   <!-- Do not add JavaScript files here; add them to jsz/makefile instead. -->
   <?cs include:"license_js_files.cs" ?>

   <?cs include:"mini-login.cs" ?>

   <script>
   $(document).click(function checkStatus() {
      MiniLogin.loggedIn();
   });
   </script>
   
</head>

<body class="tabright register-mini-login-click-handler">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

<table id="iguana">
   <tr>
      <td id="cookie_crumb">
         <a href="/settings">Settings</a> &gt; License Entitlement
      </td>
   </tr>
   <tr>
      <td id="dashboard_body">
      <center>
      <?cs if:SettingsUpdated ?>
          <div style="margin: 50px 0px;">
              <h3><font color="green">Settings updated successfully.</font></h3>
              <table>
                  <tr><td><a class="action-button green btn-xlarge" href="/dashboard.html" onclick="this.blur();">Go to Dashboard</a></td></tr>
              </table>
          </div>
      <?cs /if ?>
      <table class="configuration">
         <tr>
            <th colspan="2">Current License Information</th>
         </tr>
         <tr>
            <td class="left_column">Iguana ID</td>
            <td> <?cs var:IguanaId ?></td>
         </tr>
         <tr>
            <td class="left_column">Maximum Number of Concurrently Running Channels</td>
            <td>
               <?cs if:MaxCountOfConnection == 0 ?>
                  Unlimited
               <?cs else ?>
                  <?cs var:MaxCountOfConnection ?>
               <?cs /if ?>
            </td>
         </tr>
         <tr>
            <td class="left_column">License Expiry Date</td>
            <td>
               <?cs if:CountOfMonthToLicenseExpiry == 0 ?>
                  No Expiry
               <?cs else ?>
                  <?cs var:LicenseExpiryDate ?>
               <?cs /if ?>
            </td>
         </tr>
         <tr>
            <td class="left_column">Maintenance Expiry Date</td>
            <td>
               <?cs if:CountOfMonthToMaintenanceExpiry == 0 ?>
                  No Expiry
               <?cs else ?>
                  <?cs var:MaintenanceExpiryDate ?>
               <?cs /if ?>
            </td>
         </tr>
         <?cs if:UnlimitedLlpConnections != 0 ?>
         <tr>
            <td class="left_column">Unlimited LLP Connections</td>
            <td>Yes</td>
         </tr>
         <?cs /if ?>
      </table> <!-- /#configuration -->
      <table id="buttons" style="margin: 20px 0px;">
      <tr>
         <td>
            <?cs if:CurrentUserCanAdmin ?>
               <a id="GetLicense" href="" class="action-button blue" onclick="this.blur()"><span>Log In and Update This Activation</span></a>				     
            <?cs /if ?>			   
         </td>
         <td>
             <?cs if:CurrentUserCanAdmin ?>
               <a id="ApplyChanges" class="action-button grey" href="/edit_license_settings.html" onclick="this.blur();">Change License Code</span></a> 
             <?cs /if ?>
         </td>
         </tr>
      </table> <!-- /#buttons -->
      </center>
      </td> <!-- /#dashboard_body -->
   </tr>
</table> <!-- /#iguana -->
</div> <!-- /#main -->

<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
            <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
	     <p>
	 This page shows the current license entitlement of this server.
	 </p>
            <?cs if:CurrentUserCanAdmin ?>
	    <p>Click <b>Enter License Code</b> to update your license information.</p>
            <?cs /if ?>
         </td>
      </tr>
      <tr>
         <td class="side_item">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="<?cs var:help_link('iguana4_config_license') ?>" target="_blank">License Entitlement</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
   </div>
</body>

</html>

<script type="text/javascript">    
    $(document).ready(function(){
        var IguanaURL = [location.protocol, '//', location.host, '/'].join('');
        var RegistrationParams = "?product=iguana&version=<?cs var:VersionVer ?>&instanceid=<?cs var:IguanaId ?>&productlocation=" +
                encodeURIComponent(IguanaURL);
        var a = document.getElementById('GetLicense');
		if (a) {
			a.href = "http://my-iguana.interfaceware.com/getlicense" + RegistrationParams;
		}
    });
</script> 
