
   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/settings">Settings</a> &gt; Remote Iguana Settings
         </td>
      </tr>
      <tr>
         <td id="dashboard_body" style="text-align: center;"><center>

    <form name="remote_iguana_settings" id="remote_iguana_settings" method="post">
    <input type="hidden" id="max_row_id" name="max_row_id" value="<?cs var:html_escape(CountOfRemoteIguana) ?>">
    <div>
         <table class="configuration" id="remote_iguana_table" border="1">
            <tr class="header">
            <th>Remote Iguanas</th>
            <th>Add/Remove</th>
            </tr>
            <?cs each:Remote = RemoteIguana ?>
            <tr id="row_<?cs name:Remote ?>" >
          <td class="remote_iguana_entry">
                   <input type="hidden" name="OrigRemoteIguana_<?cs name:Remote ?>"
                     value="<?cs var:html_escape(Remote.OrigId) ?>">
                   <input type="text" name="RemoteIguana_<?cs name:Remote ?>"
                     value="<?cs var:html_escape(Remote.Id) ?>">
                   <?cs if:Remote.Error ?><small style="color: #e00101"><?cs var:html_escape(Remote.Error) ?></small><?cs /if ?>
              </td>
          <td><a class="remove_button action-button-small blue">Remove</a></td>
            </tr>
       <?cs /each ?>
       <?cs if:CanAdmin ?>
       <tr id="adding_row">
              <td class="remote_iguana_entry"><input type="text" id="NewRowField"></input>
                  <small style="color: #e00101"><span id="new_row_error"></span></small>
              </td>
              <td><a class="action-button-small blue" id="add_button">Add</a></td>
            </tr>
       <?cs /if ?>
    </table>
    </div>
      <p>

      <div id="buttons">
      <!-- edit link -->
      <?cs if:CanAdmin ?>
         <input type="hidden" name="SaveChanges" value="yes" />
         <a class="action-button blue" id="apply_changes_button">Save Changes</a>
      <?cs else ?>
         <span class="config_warning">You do not have the necessary permissions to edit these settings.</span>
     <?cs /if ?>
    </form>
         <a class="action-button blue" href="/settings#page=remote_iguana_settings/view"><span>Cancel</span></a>
      </div>
        </center>
         </td>
      </tr>
   </table>
</div>

<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
       Page Help
    </th>
      </tr>
      <tr>
         <td id="side_body">
       <h4 class="side_title">Overview</h4>
       <p>
          This page is used to list Iguana instances that can be accessed remotely through the dashboard. The same instances are also used when synchronizing user/permissions.
       </p>
       <p>
          Instances should be of the form 'http://server:port'.
       </p>
    </td>
      </tr>
   </table>
<script type="text/javascript">
$(document).ready(function() {
   var RowId = <?cs var:js_escape(CountOfRemoteIguana) ?>;
   function addRemoteRow(){
      function noDuplicates(NewValue){
         var CountOfDuplicates = 0;
         $(':input[type=text]').each( function(){
            if (this.value == NewValue) CountOfDuplicates++;
         });

         //the select includes the adding input field.
         if (CountOfDuplicates > 1){
            $('#new_row_error').text( 'This entry is already in the list of remote iguanas.' );
            return false;
         }
         return true;
      }
      var NewRowValue = $('#NewRowField').prop('value');
      if (NewRowValue){
         if(!NewRowValue.match(/^(http|https):\/\/[^:]+:[0-9]+/)){
            $('#new_row_error').text( 'Invalid format. New entry should be of the form [http/https]://<host>:<port>' );
         } else if (noDuplicates(NewRowValue)){
            $('#new_row_error').text('');
            var RowHtml = '<tr id="row_' + RowId + '">'
                        + '  <td><input size="50" type="text" name="RemoteIguana_' + RowId + '"></td>'
                        + '  <td><a class="remove_button action-button-small blue">Remove</a></td>'
                        + '</tr>';

            $(RowHtml).insertBefore($('#adding_row'));
            $(':input[name=RemoteIguana_'+RowId+']').prop('value',NewRowValue);
            RowId++;
            $('#NewRowField').prop('value','');
            return true;
         }
      } else {
         return true; //doing nothing is success
      }
      return false;
   }
   $("form#remote_iguana_settings").submit({uri: '/remote_iguanas/edit', form_id: "remote_iguana_settings"}, SettingsHelpers.submitForm);
   function doSubmit(){
      if(addRemoteRow()){
         $('#max_row_id').val(RowId);
         $("form#remote_iguana_settings").submit();
      }
   }

   function onLoad(){
      $(document).on('click', '.remove_button', function(event) {
         event.preventDefault();
         var ElRowId = $(this).parent().parent().prop('id');
         $('#' + ElRowId).remove();
      });

      $(document).on('click', '#add_button', function() {
         addRemoteRow();
      });

      //this sets up Enter key behaviour to add a row
      $(document).keypress(function(e){
         if (e.keyCode === 13) {
            e.preventDefault();
            addRemoteRow();
         }
      });
   }
   $("#apply_changes_button").click(doSubmit);
   onLoad();
});
</script>


